# coding: utf-8

"""
    Karbon Platform Services API reference.

    OpenAPI documentation for public facing Karbon Platform Services API  This API documentation is generated from source code using go-swagger. Do not edit the generated kps_api.json directly!  # noqa: E501

    OpenAPI spec version: 1.0
    Contact: karbon-platform-services-api@nutanix.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six


class EdgeUpgrade(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'changelog': 'str',
        'compatible_releases': 'list[str]',
        'id': 'str',
        'release': 'str'
    }

    attribute_map = {
        'changelog': 'changelog',
        'compatible_releases': 'compatibleReleases',
        'id': 'id',
        'release': 'release'
    }

    def __init__(self, changelog=None, compatible_releases=None, id=None, release=None):  # noqa: E501
        """EdgeUpgrade - a model defined in Swagger"""  # noqa: E501
        self._changelog = None
        self._compatible_releases = None
        self._id = None
        self._release = None
        self.discriminator = None
        self.changelog = changelog
        self.compatible_releases = compatible_releases
        if id is not None:
            self.id = id
        self.release = release

    @property
    def changelog(self):
        """Gets the changelog of this EdgeUpgrade.  # noqa: E501

        The changes that were made in this release from the previous release  # noqa: E501

        :return: The changelog of this EdgeUpgrade.  # noqa: E501
        :rtype: str
        """
        return self._changelog

    @changelog.setter
    def changelog(self, changelog):
        """Sets the changelog of this EdgeUpgrade.

        The changes that were made in this release from the previous release  # noqa: E501

        :param changelog: The changelog of this EdgeUpgrade.  # noqa: E501
        :type: str
        """
        if changelog is None:
            raise ValueError("Invalid value for `changelog`, must not be `None`")  # noqa: E501

        self._changelog = changelog

    @property
    def compatible_releases(self):
        """Gets the compatible_releases of this EdgeUpgrade.  # noqa: E501

        List of releases that can be upgraded to the new version  # noqa: E501

        :return: The compatible_releases of this EdgeUpgrade.  # noqa: E501
        :rtype: list[str]
        """
        return self._compatible_releases

    @compatible_releases.setter
    def compatible_releases(self, compatible_releases):
        """Sets the compatible_releases of this EdgeUpgrade.

        List of releases that can be upgraded to the new version  # noqa: E501

        :param compatible_releases: The compatible_releases of this EdgeUpgrade.  # noqa: E501
        :type: list[str]
        """
        if compatible_releases is None:
            raise ValueError("Invalid value for `compatible_releases`, must not be `None`")  # noqa: E501

        self._compatible_releases = compatible_releases

    @property
    def id(self):
        """Gets the id of this EdgeUpgrade.  # noqa: E501

        ID of the entity Maximum character length is 64 for project, category, and runtime environment, 36 for other entity types.  # noqa: E501

        :return: The id of this EdgeUpgrade.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this EdgeUpgrade.

        ID of the entity Maximum character length is 64 for project, category, and runtime environment, 36 for other entity types.  # noqa: E501

        :param id: The id of this EdgeUpgrade.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def release(self):
        """Gets the release of this EdgeUpgrade.  # noqa: E501

        This is the release that is avaliable  # noqa: E501

        :return: The release of this EdgeUpgrade.  # noqa: E501
        :rtype: str
        """
        return self._release

    @release.setter
    def release(self, release):
        """Sets the release of this EdgeUpgrade.

        This is the release that is avaliable  # noqa: E501

        :param release: The release of this EdgeUpgrade.  # noqa: E501
        :type: str
        """
        if release is None:
            raise ValueError("Invalid value for `release`, must not be `None`")  # noqa: E501

        self._release = release

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(EdgeUpgrade, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, EdgeUpgrade):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
